"use strict";

const color = require('colors');
const moment = require('moment-timezone');
const lmode = { info : 0, warn : 1, error : 2, fatal : 3, debug : 4 };

class Logger {
    constructor(){}

    i(){ return this.log(lmode.info, arguments); }
    w(){ return this.log(lmode.warn, arguments); }
    e(){ return this.log(lmode.error, arguments); }
    f(){ return this.log(lmode.fatal, arguments); }
    d(){ return this.log(lmode.debug, arguments); }

    log(type, text){
        let mode = "", log = "", c, time = moment().tz("Asia/Tehran").format("YYYY-MM-DD HH:mm:ss.ms");

        for(let i=0; i<text.length; i++){
            if( typeof text[i] == "object" ) text[i] = JSON.stringify(text[i]);
            text[i] = text[i] != null ? text[i] : "null";
            log += text[i].toString();
            if( i < text.length-1 )
                log += " | ";
        }

        switch (type) {
            case lmode.info :  mode = "INFO"; c = color.green; break; // info
            case lmode.warn :  mode = "WARN"; c = color.yellow; break; // warn
            case lmode.error :  mode = "ERROR"; c = color.red; break; // error
            case lmode.fatal :  mode = "FATAL"; c = color.red; break; // fatal
            case lmode.debug :  mode = "DEBUG"; c = color.white; break; // debug
        }
        log = "["+time+"] " + "["+mode+"] - " + log;
        console.log( c(log) );
    }
}

module.exports = new Logger();



